#include <SDL.h>
#include "menu.h"
#include <sys/types.h>

#define MENU_FILE_TEXT "data/text.bmp"
#define MENU_FILE_TEXT_INV "data/text2.bmp"

SDL_Surface *text_screen=NULL, *text_image=NULL, *text_image_inv=NULL, *text_background=NULL;
//SDL_Surface *screen = NULL;

int fullscreen=0;

void init_text(SDL_Surface *screen,int splash);
void text_flip(SDL_Surface *screen);
static void write_text_common(int x, int y, char * str, SDL_Surface *txt_scr);
void write_text(int x, int y, char * str);


void init_text(SDL_Surface *screen,int splash){
	screen = SDL_SetVideoMode(320, 240, 16,SDL_HWSURFACE|(fullscreen ? SDL_FULLSCREEN : 0)); 
	if (!text_screen)
	{
		text_screen=SDL_DisplayFormat(screen);
		if (text_screen==NULL)
		{
			//exit(-1);
		}
	}
	
	if (!text_image)
	{
		SDL_Surface *tmp=SDL_LoadBMP(MENU_FILE_TEXT);
		if (tmp==NULL)
		{
			exit(-1);
		}
		text_image=SDL_DisplayFormat(tmp);
		SDL_FreeSurface(tmp);
		SDL_SetColorKey(text_image,(SDL_SRCCOLORKEY | SDL_RLEACCEL),SDL_MapRGB(text_image -> format, 0, 0, 0));
	}
	
	if (!text_image_inv)
	{
		SDL_Surface *tmp=SDL_LoadBMP(MENU_FILE_TEXT_INV);
		if (tmp==NULL)
		{
			//puts("No se pudo crear el SDL_Surface text_screen o cargar " MENU_FILE_TEXT_INV);
			exit(-1);
		}
		text_image_inv=SDL_DisplayFormat(tmp);
		SDL_FreeSurface(tmp);
		SDL_SetColorKey(text_image_inv,(SDL_SRCCOLORKEY | SDL_RLEACCEL),SDL_MapRGB(text_image -> format, 0, 0, 0));
	}
	{
		//text_draw_background();
		text_flip(screen);
	}
	if (splash)
	{
		//obten_colores();
		//menu_msg_time=SDL_GetTicks();
	}
}

void text_flip(SDL_Surface *screen)
{
	static Uint32 t;
	Uint32 now=SDL_GetTicks();
	if ((now-t)<10)
		SDL_Delay(now-t);
	t=now;
	SDL_BlitSurface(text_screen,NULL,screen,NULL);
	SDL_Flip(screen);
}

static void write_text_common(int x, int y, char * str, SDL_Surface *txt_scr)
{
  int i, c;
  SDL_Rect src, dest;
  
  x-=4;

  for (i = 0; i < strlen(str); i++)
    {
      c = -1;
      
      if (str[i] >= '0' && str[i] <= '9')
	c = str[i] - '0';
      else if (str[i] >= 'A' && str[i] <= 'Z')
	c = str[i] - 'A' + 10;
      else if (str[i] >= 'a' && str[i] <= 'z')
	c = str[i] - 'a' + 36;
      else if (str[i] == '#')
	c = 62;
      else if (str[i] == '=')
	c = 63;
      else if (str[i] == '.')
	c = 64;
      else if (str[i] == '_')
	c = 68;
      else if (str[i] == '-')
	c = 68;
      else if (str[i] == '/')
	c = 65;
      else if (str[i] == ',')
	c = 66;
      else if (str[i] == ':')
	c = 67;
      
      if (c >= 0)
	{
	  src.x = c * 8;
	  src.y = 0;
	  src.w = 8;
	  src.h = 8;
	  
	  dest.x = (x + i) * 8;
	  dest.y = y * 8; //10;
	  dest.w = 8;
	  dest.h = 8;
	  
	  SDL_BlitSurface(txt_scr, &src,
			  text_screen, &dest);
			  //screen, &dest);
	}
    }
}

void write_text(int x, int y, char * str)
{
	write_text_common(x,y,str,text_image);
}

